#include <stdio.h>

  /* Ograniceni Hanojski tornjevi s n diskova.
     Prebacivanje je dozvoljeno samo na susjedni stap.
     Ispisuje redosljed poteza, tj.
     prebacivanja (najgornjih) diskova. */

void prebaci_jednog(int odakle, int kamo)
{
    printf("  prebaci s %d na %d\n", odakle, kamo);

    return;
}

    /* Funkcija ima sva tri stapa u argumentima, ukljucivo i pomocni.
       Ima nepotrebne pozive za n = 0 (koji nista ne rade). */

void Ogr_Hanojski_tornjevi(int n, int odakle, int kamo, int pomocni)
{
    if (n > 0) {
        Ogr_Hanojski_tornjevi(n - 1, odakle, kamo, pomocni);
        prebaci_jednog(odakle, pomocni);
        Ogr_Hanojski_tornjevi(n - 1, kamo, odakle, pomocni);
        prebaci_jednog(pomocni, kamo);
        Ogr_Hanojski_tornjevi(n - 1, odakle, kamo, pomocni);
    }

    return;
}

int main(void)
{
    int n;

    for (n = 1; n <= 4; ++n) {
        printf("\n Prebaci %d diskova s 1 na 3:\n", n);
        Ogr_Hanojski_tornjevi(n, 1, 3, 2);
    }

    return 0;
}
