#include <stdio.h>
#include "vekt.h"

  /* Primjer za operacije s vektorima u R^3. */

int main(void)
{
    double a[3] = { 1.0, 2.0, 0.0 };
    double b[3] = { 0.0, 1.0, 1.0 };
    double c[3];

    printf(" a = ");  vekt_print(a);
    printf(" b = ");  vekt_print(b);

    printf("  norma(a) = %g\n", norma(a));
    printf("  norma(b) = %g\n", norma(b));

    printf("     a * b = %g\n", skal_prod(a, b));
    printf(" cos(a, b) = %g\n", kosinus_kuta(a, b));

    zbroj(a, b, c);
    printf(" a + b = ");  vekt_print(c);

    vekt_prod(a, b, c);
    printf(" a x b = ");  vekt_print(c);

    return 0;
}
