#include <stdio.h>
#include <string.h>

  /* Uvod u stringove: razlika izmedju stringa i polja znakova,
     duljina polja, duljina stringa (funkcija strlen). */

int main(void)
{
        /* Polje c NIJE string, a polje s JE string. */
    char c[] = {'t', 'r', 'i'};
    char s[] = "tri";

        /* Polja s1 i s2 su stringovi, zbog dopune nulama (nul-znakovima). */
    char s1[10] = "tri";
    char s2[10] = {'t', 'r', 'i'};

        /* Dodatni primjeri za inicijalizaciju. */
    char t1[] = "Init";
    char t2[5] = "Init";
    char t3[] = {'I', 'n', 'i', 't', '\0'};
    char t4[5] = {'I', 'n', 'i', 't', '\0'};


        /* Polje c NIJE string - nema nul-znaka.
           Ponasanje funkcije strlen na c NIJE definirano
           (funkcija trazi prvi nul-znak u memoriji iza polja c). */
    printf(" Polje  c  ima %u elemenata\n", sizeof(c));
    printf(" String c  ima %u znakova\n", strlen(c));
    printf(" Znak c[2] ima kod %d\n", c[2]);
        /* Znak c[3] je IZVAN (IZA) polja c.
           Kompajler javlja gresku (warning). */
    printf(" Znak c[3] ima kod %d\n", c[3]);
    printf("\n");

        /* Polje s JE string - sadrzi nul-znak. */
    printf(" Polje  s  ima %u elemenata\n", sizeof(s));
    printf(" String s  ima %u znakova\n", strlen(s));
    printf(" Znak s[2] ima kod %d\n", s[2]);
    printf(" Znak s[3] ima kod %d\n", s[3]);
    printf("\n");

        /* Polja s1 i s2 su stringovi, zbog dopune nulama (nul-znakovima). */
    printf(" Polje  s1 ima %u elemenata\n", sizeof(s1));
    printf(" String s1 ima %u znakova\n", strlen(s1));
    printf(" Znak s1[2] ima kod %d\n", s1[2]);
    printf(" Znak s1[3] ima kod %d\n", s1[3]);
    printf(" Znak s1[4] ima kod %d\n", s1[4]);
    printf(" Znak s1[5] ima kod %d\n", s1[5]);
    printf("\n");

    printf(" Polje  s2 ima %u elemenata\n", sizeof(s2));
    printf(" String s2 ima %u znakova\n", strlen(s2));
    printf(" Znak s2[2] ima kod %d\n", s2[2]);
    printf(" Znak s2[3] ima kod %d\n", s2[3]);
    printf(" Znak s2[4] ima kod %d\n", s2[4]);
    printf(" Znak s2[5] ima kod %d\n", s2[5]);
    printf("\n\n");

        /* Dodatni primjeri za inicijalizaciju. */
    printf(" String t1 ima %u znakova\n", strlen(t1));
    printf(" String t2 ima %u znakova\n", strlen(t2));
    printf(" String t3 ima %u znakova\n", strlen(t3));
    printf(" String t4 ima %u znakova\n", strlen(t4));

    return 0;
}
