#include <stdio.h>

/****************************************************************************/

  /* Uzlazno sortiranje zamjenama susjeda.
     Skracena vanjska petlja - sve
     dok ima zamjena u unutarnjoj.
     Umjesto do-while, koristi silaznu for petlju,
     a izlazak iz petlje je s break.
     Indeks j unutarnje petlje je veci za 1. */

void bubble_sort(int x[], int n)
{
    int i, j, temp, zamjena;

        /* i je indeks zadnjeg elementa u
           sljedecem prolazu. */
    for (i = n - 1; i >= 1; --i) {
        zamjena = 0;
        for (j = 1; j <= i; ++j)
            if (x[j - 1] > x[j]) {
                temp = x[j - 1];
                x[j - 1] = x[j];
                x[j] = temp;
                zamjena = 1;
            }
        if (!zamjena) break;
    }

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    bubble_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
