#include <stdio.h>
#include <stdlib.h>

/****************************************************************************/

  /* Sortiranje QuickSort algoritmom. Varijanta iz <stdlib.h>. */

    /* Funkcija za usporedbu intova - treba za qsort.
       Spora funkcija za usporedbu (prvo test jednakosti). */

int cmp_int(const void *p1, const void *p2)
{
    int n1 = *(int *) p1, n2 = *(int *) p2;

    if (n1 == n2)
        return 0;
    else if (n1 > n2)
        return 1;
    else
        return -1;
}

/* ======================================================================== */

    /* Glavna funkcija za sortiranje, koja se zove izvana. */

void q_sort(int x[], int n)
{
    qsort(x, n, sizeof(int), cmp_int);

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    q_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
