#include <stdio.h>

  /* Broj rijeci u stringu, 1. varijanta:
       razmak = izmedju rijeci (u razmaku),
       brojanje na izlazu iz rijeci. */

#define TRUE 1
#define FALSE 0

int broj_rijeci(char *str)
{
    int brojac = 0;
    int razmak = TRUE;    /* Ispred prve rijeci. */

    while (*str != '\0') {
        if (*str == ' ' || *str == '\t') {
            if (!razmak) {    /* Izlaz iz rijeci. */
                ++brojac;
                razmak = TRUE;
            }
        }
        else    /* Dio rijeci. */
            razmak = FALSE;
        ++str;
    }

    if (!razmak) ++brojac;    /* Zadnja rijec! */

    return brojac;
}

int main(void)
{
    char s[] = "Ja sam mala Ruza, mamina sam kci.";

    printf("String:\n");
    printf("%s\n", s);

    printf("Broj rijeci: %d\n", broj_rijeci(s));

    return 0;
}
