#include <stdio.h>
#include <stdlib.h>

  /* Primjer za dinamicki alocirano polje.
     Broj elemenata se cita s komandne linije. */

int main(int argc, char *argv[])
{
    int *a;    /* Pokazivac na dinamicko polje. */
    int i, n, zbroj;

        /* Provjera broja argumenata na komandnoj liniji. */
    if (argc < 2) {
        printf("Broj elemenata nije zadan.\n");
        exit(EXIT_FAILURE);    /* exit(1); */
    }
        /* Prvi argument pretvaramo u broj n, provjerimo ga. */
    n = atoi(argv[1]);
    if (n <= 0) {
        printf("Broj elemenata nije pozitivan.\n");
        exit(EXIT_FAILURE);    /* exit(1); */
    }

    if ((a = (int*) calloc(n, sizeof(int))) == NULL) {
        printf("Alokacija nije uspjela.\n");
        exit(EXIT_FAILURE);    /* exit(1); */
    }
    for (i = 0; i < n; ++i) {
        printf("Upisi element polja a[%d]: ", i);
        scanf("%d", &a[i]);
    }
    zbroj = 0;
    for (i = 0; i < n; ++i)
        zbroj = zbroj + a[i];
    printf("Zbroj svih elemenata = %d\n", zbroj);

    free(a);    /* Ne treba a = NULL; gotovi smo. */

    return 0;
}
