#include <stdio.h>
#include <ctype.h>

  /* Primjer implementacije funkcije atoi,
     za pretvaranje stringa u cijeli broj. */

int f_atoi(const char s[])
{
        /* Indeks, broj, predznak. */
    int i, n, sign;

        /* Preskace sve bjeline, prazan for. */
    for (i = 0; isspace(s[i]); ++i) ;

        /* Postavi predznak (kao broj)! */
    sign = (s[i] == '-') ? -1 : 1;

        /* Preskoci predznak, ako ga ima. */
    if (s[i] == '+' || s[i] == '-') ++i;

        /* Hornerov algoritam za broj. */
    for (n = 0; isdigit(s[i]); ++i)
        n = 10 * n + (s[i] - '0');

   return sign * n;
}

int main(void)
{
    char s[] = "  -1234";

    printf("String:\n");
    printf("%s\n", s);

    printf("Broj: %d\n", f_atoi(s));

    return 0;
}
