#include <stdio.h>
#include <math.h>
#include "tocka.h"

  /* Implementacija nekih operacija s tockama u ravnini. */

/* ======================================================================== */

    /* Udaljenost tocaka. */

double udaljenost(tocka A, tocka B)
{
    double dx = A.x - B.x;
    double dy = A.y - B.y;
    return sqrt(dx * dx + dy * dy);
}

    /* Udaljenost tocke od ishodista. */

double udaljenost_od_ishodista(tocka A)
{
    tocka O = { 0.0, 0.0 };
    return udaljenost(A, O);
}

    /* Centralno simetricna tocka obzirom na ishodiste. */

tocka centralno_simetricna(tocka A)
{
    A.x = -A.x;
    A.y = -A.y;
    return A;
}

    /* Translacija prve tocke za drugu tocku (vektor). */

void translatiraj_tocku(tocka *A, tocka B)
{
    A->x = A->x + B.x;
    A->y = A->y + B.y;
    return;
}

    /* Ispis tocke u obliku ime_tocke(x, y). */

void ispisi_tocku(char *ime_tocke, tocka A)
{
    printf("%s(%g, %g)\n", ime_tocke, A.x, A.y);
    return;
}
