#include <stdio.h>

/****************************************************************************/

  /* Uzlazno sortiranje zamjenama susjeda.
     Skracena vanjska petlja - pamti
     indeks zadnje zamjene u unutarnjoj.
     Umjesto do-while, koristi silaznu for petlju,
     a novi indeks je indeks zadnje zamjene.
     Indeks j unutarnje petlje je veci za 1. */

void bubble_sort(int x[], int n)
{
    int i, j, ind_zamj, temp;

        /* i je indeks zadnjeg elementa u
           sljedecem prolazu. Spusta se na
           indeks zadnje zamjene (a ne za 1). */
    for (i = n - 1; i >= 1; i = ind_zamj) {
        ind_zamj = -1;
        for (j = 1; j <= i; ++j)
            if (x[j - 1] > x[j]) {
                temp = x[j - 1];
                x[j - 1] = x[j];
                x[j] = temp;
                ind_zamj = j - 1;
            }
    }

    return;
}

/****************************************************************************/

int main(void)
{
    int i, n;
    int x[] = {42, 12, 55, 94, 18, 44, 67};

    n = 7;
    bubble_sort(x, n);

    printf("\n Sortirano polje x:\n");
    for (i = 0; i < n; ++i) {
        printf(" x[%d] = %d\n", i, x[i]);
    }

    return 0;
}
