#include <stdio.h>
#include <stdlib.h>

  /* Funkcija qsort, uzlazno sortiranje polja intova.
     Primjer 2a: pazi na tipove kod poziva qsort.
       - Funkcija za usporedbu prima pokazivace na void (kako qsort ocekuje),
         a tipovi se eksplicitno pretvaraju UNUTAR funkcije.
       Druga varijanta za zapis tipa - jedan par zagrada. */

    /* Funkcija usporedi ima tip kojeg qsort ocekuje. */

int usporedi(const void *p_a, const void *p_b)
{
    int a = * (int *) p_a, b = * (int *) p_b;

  /* Nije dobro: return a - b;
     jer rezultat ne mora biti korektno prikaziv! */

    if (a < b)
        return -1;
    else if (a > b)
        return 1;
    else
        return 0;
}

int main(void)
{
    int i, polje[4] = {1, 3, -4, 2};

    qsort(polje, 4, sizeof(int), usporedi);

    for (i = 0; i < 4; ++i)
        printf("%d\n", polje[i]);

    return 0;
}
